<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<!-- Bootstrap CSS -->
	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css" integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn" crossorigin="anonymous">
	<title>Bootstrap Grid System</title>
</head>
<body>

	<h1 class="text-center">Bootstrap Grid System</h1>

	<!-- Two-column layout -->
	<h2 class="text-center">Two-Column Layout</h2>
	<!-- class container with grid -->
<!-- 	<div class="container bg-dark">
		<h3 class="text-center text-white">1:1 Ratio</h3>
		<div class="row text-white text-center">
			<div class="bg-primary p-3 border border-dark col-6">6 Columns</div>
			<div class="bg-danger p-3 border border-dark col-6">6 Columns</div>
		</div>
	</div> -->
	<div class="container-fluid bg-secondary mt-3">
		<h3 class="text-center">1:1 Ratio</h3>
		<div class="row text-white text-center">
			<div class="bg-primary p-3 border border-dark col-6">6 Columns</div>
			<div class="bg-danger p-3 border border-dark col-6">6 Columns</div>
		</div>
		<h3 class="text-center">1:2 Ratio</h3>
		<div class="row text-center mt-3">
			<div class="bg-info border border-dark col-4 p-3">4 Columns</div>
			<div class="bg-warning border border-dark col-8 p-3">8 Columns</div>
			<!-- If the number of columns in a row exceeds 12, the next div will overflow the next line. -->
			<div class="bg-success border border-dark col-3 p-3">3 Columns</div>
		</div>
	</div>
	
	<!-- Bootstrap Grid System runs on a rule of CRC


		Container - sets the max width of our grid system.
		Row - holds 12 columns. Each row is divided equally to 12.
		Column - is where our content will be added. 

	-->

	<!-- Three-column layout -->
	<h2 class="text-center my-5">Three-Column Layout</h2>
	<div class="container-fluid bg-secondary">
		<h3 class="text-center">1:1:1 Ratio</h3>
		<div class="row text-center">
			<div class="col-4 bg-info border border-dark p-3">4 Columns</div>
			<div class="col-4 bg-warning border border-dark p-3">4 Columns</div>
			<div class="col-4 bg-success border border-dark p-3">4 Columns</div>
		</div>
		<h3 class="text-center">Uneven Columns</h3>
		<div class="row text-center">
			<div class="col-5 bg-primary border border-dark p-3">5 Columns</div>
			<div class="col-4 bg-danger border border-dark p-3">4 Columns</div>
			<div class="col-3 bg-success border border-dark p-3">3 Columns</div>
		</div>
	</div>

	<!-- columns with content -->
	<h2 class="text-center my-5">Column With Sample Content</h2>
	<div class="container-fluid bg-dark text-white">
		<div class="row">
			<div class="col-6 p-3">
				<h3>Sample Content</h3>
				<p class="mt-2">
					Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod
					tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam,
					quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo
					consequat. 
				</p>
			</div>
			<div class="col-6 p-3">
				<img src="https://place-puppy.com/1000x1000" class="rounded-circle img-fluid">
			</div>
		</div>
	</div>

	<h3 class="text-center my-5">Mini-Activity with 3 columns</h3>
	<div class="container-fluid bg-secondary">
		<div class="row">
			<div class="col-5 p-3">
				<h3 class="text-center">This text's column is bigger than the picture</h3>
			</div>
			<div class="col-2 p-3">
				<img src="https://placebear.com/500/500" class="img-fluid">
			</div>
			<div class="col-5 p-3">
				<p>This text's column is bigger than the picture.</p>
			</div>
		</div>
	</div>
	<!-- auto columns -->
	<h2 class="my-5 text-center">Auto Columns</h2>
	<!-- To add the number of colunns a dif in a row can occupy the syntax of the bootstrap class is this: col-<#col> -->
	<div class="container-fluid bg-secondary">
		<div class="row">
			<!-- When a creating a column but not providing the total number of grid columns to occupy, bootstrap will then assign and calculate the total number of columns left in the row and assign it per auto column accordingly. -->
			<div class="bg-danger border border-dark p-3 col">Auto 1</div>
			<div class="bg-success border border-dark p-3 col">Auto 2</div>
			<div class="bg-info border border-dark p-3 col">Auto 3</div>
			<div class="bg-success border border-dark p-3 col">Auto 4</div>
			<div class="bg-light border border-dark p-3 col">Auto 5</div>
			<div class="bg-secondary border border-dark p-3 col">Auto 6</div>
			<div class="bg-primary border border-dark p-3 col">Auto 7</div>
		</div>
		<div class="row my-5">
			<div class="col-6 bg-primary border border-dark">
				Column 6
			</div>
			<div class="col bg-success border border-dark">Auto</div>
			<div class="col bg-info border border-dark">Auto</div>
			<div class="col bg-danger border border-dark">Auto</div>
		</div>
	</div>

	<!-- breakpoints and columns -->
	<h2 class="my-5 text-center">Breakpoints and columns</h2>
	<div class="container-fluid bg-dark">
		<div class="row">
			<!-- By default, a column will occupy 12 columns until its breakpoint. A breakpoint is the screen, or screen size wherein the number of columns given will take effect. -->
			<div class="col-lg-6 bg-danger border border-dark p-3">6 Cols in lg, 12 cols in xs</div>
			<!-- By decaling or adding col without breakpoint this means that this div has 6 columns from the smallest screen to the largest. -->
			<div class="col-6 bg-primary border border-dark p-3">6 Cols all screens</div>
		</div>
		<div class="row my-5">
			<!-- column without breakpoint means the number of columns from the smallest screen until the breakpoint. From the breakpoint, lg, this div is now 8 columns. -->
			<div class="col-3 col-lg-8 bg-info border border-dark p-3">
				col-lg-8
			</div>
			<!-- Without setting the number of columns from the smallest screen, by default, the column will occupy 12 columns until breakpoint. -->
			<div class="col-md-4 bg-warning border border-dark p-3">
				col-md-4
			</div>
		</div>
		<!-- 

			Breakpoints

			You can set the number of columns a div occupies per screen using breakpoints.
			However, by default from the smallest screen a div with class col will occupy 12 columns.

			This is because Bootstrap is a mobile-first approach to styling a web page.

			Since Bootstrap takes a mobile-first appriach, the default breakpoint is for the smallest screen.

			Meaning until you add a breakpoint (sm, md, lg, xl) the number of columns a div will occupy will be the same from the smallest to the largest screen.

			Columns can be sized with breakpoints starting from the smallest screen:

			col-* - from the smallest screen.
			col-sm-* - breakpoint from small screen or about 576px screen width.
			col-md-* - breakpoint from medium screen or tablet or about 768px screen width.
			col-lg-* - breakpoint from the large screen or laptop or 992px screen width.
			col-xl-* - breakpoint from the largest screen or 1200px screen width.

			If a div in a row has the following classes:
			col-6 col-md-10
			How many columns does the div occupy in the smallest screen? 6
			How many columns does the div occupy in the medium screen? 10
			How many columns does the div occupy in the largest screen? 10

			col-sm-10
			How many columns does the div occupy in the smallest screen? 12
			How many columns does the div occupy in the small screen? 10
			How many columns does the div occupy in the medium screen? 10
			How many columns does the div occupy in the largest screen? 10


		-->
		<h3 class="text-center my-5 text-white">Mini Activity with Breakpoints</h3>
		<div class="row mb-5">
			<div class="col-6 bg-primary border border-dark p-3">col-6</div>
			<div class="col-6 col-md-10 bg-danger border border-dark p-3">col-6 col-md-10</div>
		</div>
		<div class="row">
			<div class="col-md-8 bg-success border border-dark p-3">col-12 col-md-8</div>
			<div class="col-6 col-md-2 bg-info border border-dark p-3">col-6 col-md-2</div>
			<div class="col-6 col-md-2 bg-info border border-dark p-3">col-6 col-md-2</div>
		</div>

		<!-- Breakpoints with text alignment -->
		<!-- Default alignment of text: text-left -->
		<h3 class="text-md-center my-5 text-white">Text Alignment with breakpoints</h3>
		<div class="row">
			<div class="col-6 col-md-8 text-right text-md-left bg-primary border border-dark p-3">Div 1</div>
			<div class="col-6 col-md-4 text-md-right bg-danger border border-dark p-3">Div 2</div>
		</div>

		<h2 class="text-center my-5 text-white">Display Order with Breakpoint</h2>
		<div class="row">
			<div class="col-6 col-md-10 order-2 order-md-1 bg-warning border border-dark p-3">Div 1</div>
			<div class="col-6 col-md-2 order-1 order-md-2 bg-primary border border-dark p-3">Div 2</div>
		</div>

		<h3 class="text-md-center my-5 text-white">Mini-Activity with order</h3>
		<div class="row">
			<div class="col-4 order-1 order-md-2 order-lg-3 bg-warning border border-dark p-3">Lebron</div>
			<div class="col-4 order-3 order-md-1 order-lg-2 bg-primary border border-dark p-3">Curry</div>
			<div class="col-4 order-2 order-md-3 order-lg-1 bg-secondary border border-dark p-3 text-white">Durant</div>
		</div>
	</div> <!-- ./div class="container-fluid bg-dark"-->


	<!-- offsetting columns -->

	<div style="margin-top:500px"></div>
	<!-- Javascript -->
	<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-fQybjgWLrvvRgtW6bFlB7jaZrFsaBXjsOMm/tB9LTS58ONXgqbR9W8oWht/amnpF" crossorigin="anonymous"></script>
</body>
</html>